#include <libxml/tree.h>

#include <stdio.h>
#include <string.h>

int get_val_str(xmlElementPtr partition, const char *name, char *value, size_t value_len)
{
	const char *val = "";
	xmlAttrPtr node;
	xmlNodePtr child;

	for (node = (xmlAttrPtr) partition->attributes; node; node = node->next)
	{
		if (strcmp((const char *)(node->name), name))
			continue;

		if (node->type != XML_ATTRIBUTE_NODE)
			return -1;

		if (!node->children)
			return -1;

		child = node->children;
		if (child)
			val = (const char*) child->content;

		break;

	}

	if (strlen(val) >= value_len)
		return -1;

	strcpy(value, val);

	return 0;
}

int get_val_int(xmlElementPtr partition, const char *name)
{
	char number[32];

	number[0] = 0;

	get_val_str(partition, name, number, sizeof number);

	return atoi(number);
}
